;;;Elise Moss
;;;Moss Designs
;;;routine locates all attributes in a drawing and changes them to text
;;;December 2001
;;;
(defun c:a2t (/)
  (setq ss (ssget "x" (list (cons 0 "INSERT"))))
					; create list of all inserts

  (setq sslen (sslength ss))		; get number of inserts
  (setq index 0)
  (if (= tblsearch "LAYER" "ATT-TEXT" nil)
    (command "-layer" "n" "att-text, att-hid" "")
					; create two new layers one for attributes and one for hidden attributes
  )
  (if (/= tblsearch "LAYER" "ATT-HID" nil)
    (command "-layer" "f" "att-hid" "")
  )
  (while (< index sslen)		; while index is less than the length of ss
    (progn
      (setq ename (ssname ss index))
      (setq en ename)

      (while (/= en nil)		; as long as there are entities
	(setq ent-list (entget en))
	(setq typ (cdr (assoc 0 ent-list)))
	(while (= typ "INSERT")
	  (progn
	    (setq ent-list (entget en))
	    (setq en (entnext en))
	    (setq ent-list (entget en))
	    (setq typ (cdr (assoc 0 ent-list)))
	  )				;end progn
	)				; end while type = insert
	(while (= typ "ATTRIB")
	  (progn
	    (setq val (cdr (assoc 1 ent-list))) ; get text value
	    (setq flag (cdr (assoc 70 ent-list)))
					; get attribute type if flag = 1 invisible
	    (setq txtht (cdr (assoc 40 ent-list)))
					; get attribute text height
	    (setq txtloc (cdr (assoc 10 ent-list)))
					; get insertion point for text
	    (setq txtrot (cdr (assoc 50 ent-list))) ; get text rotation
	    (if (= "TEXTSIZE" 0)
	    	(command "text" txtloc txtht txtrot val "")
	    )
	    (if (/= "TEXTSIZE" 0)
	    	(command "text" txtloc txtrot val "")
	    )
	    (if	(= flag 1)
	      (command "chprop" "l" "" "la" "att-hid" "")
	    )
	    (if	(= flag 0)
	      (command "chprop" "l" "" "la" "att-text" "")
	    )

	    (setq en (entnext en))
	    (setq ent-list (entget en))
	    (setq typ (cdr (assoc 0 ent-list)))
	  )				;end progn
	)				; end while typ = attrib
	(setq en (entnext en))

      )					; end while en /= nil
;;;        (command "erase" ename "")

      (setq index (+ index 1))

    )					; end progn
  )					; end while index < sslen
  (command "regen")
  (princ)

)					; end defun
(prompt "\nType 'a2t' to change all attributes to text. ")

















